Allow rebase to run if upstream is completely merged
[git/git.git] / git-rebase.sh
CommitLineData
59e6b23a
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano.
4#
5
1b1dce4b 6USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
031321c6
SE
7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8same name. When the --onto option is provided the new branch starts
9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10It then attempts to create a new commit for each commit from the original
11<branch> that does not exist in the <upstream> branch.
69a60af5 12
031321c6
SE
13It is possible that a merge failure will prevent this process from being
14completely automatic. You will have to resolve any such merge failure
cc120056
SE
15and run git rebase --continue. Another option is to bypass the commit
16that caused the merge failure with git rebase --skip. To restore the
17original <branch> and remove the .dotest working files, use the command
18git rebase --abort instead.
69a60af5 19
031321c6
SE
20Note that if <branch> is not specified on the command line, the
21currently checked out branch is used. You must be in the top
22directory of your project to start (or continue) a rebase.
e646c9c8 23
031321c6 24Example: git-rebase master~1 topic
e646c9c8 25
031321c6
SE
26 A---B---C topic A'\''--B'\''--C'\'' topic
27 / --> /
28 D---E---F---G master D---E---F---G master
e646c9c8 29'
533b7039
JH
30
31SUBDIRECTORY_OK=Yes
ae2b0f15 32. git-sh-setup
f9474132 33set_reflog_action rebase
7eff28a9 34require_work_tree
533b7039 35cd_to_toplevel
4282c4fb 36
cc120056
SE
37RESOLVEMSG="
38When you have resolved this problem run \"git rebase --continue\".
39If you would prefer to skip this patch, instead run \"git rebase --skip\".
40To restore the original branch and stop rebasing run \"git rebase --abort\".
41"
e646c9c8 42unset newbase
a06f678e 43strategy=recursive
58634dbf
EW
44do_merge=
45dotest=$GIT_DIR/.dotest-merge
46prec=4
b758789c 47verbose=
67dad687 48git_am_opt=
58634dbf
EW
49
50continue_merge () {
51 test -n "$prev_head" || die "prev_head must be defined"
52 test -d "$dotest" || die "$dotest directory does not exist"
53
5be60078 54 unmerged=$(git ls-files -u)
58634dbf
EW
55 if test -n "$unmerged"
56 then
57 echo "You still have unmerged paths in your index"
9b07873a 58 echo "did you forget to use git add?"
66eb64cb 59 die "$RESOLVEMSG"
58634dbf
EW
60 fi
61
5be60078 62 if ! git diff-index --quiet HEAD
58634dbf 63 then
f0ef0596
EW
64 if ! git-commit -C "`cat $dotest/current`"
65 then
66 echo "Commit failed, please do not call \"git commit\""
67 echo "directly, but instead do one of the following: "
68 die "$RESOLVEMSG"
69 fi
9e4bc7dd 70 printf "Committed: %0${prec}d" $msgnum
58634dbf 71 else
9e4bc7dd 72 printf "Already applied: %0${prec}d" $msgnum
58634dbf 73 fi
5be60078 74 echo ' '`git rev-list --pretty=oneline -1 HEAD | \
9e4bc7dd 75 sed 's/^[a-f0-9]\+ //'`
58634dbf 76
5be60078 77 prev_head=`git rev-parse HEAD^0`
58634dbf 78 # save the resulting commit so we can read-tree on it later
58634dbf
EW
79 echo "$prev_head" > "$dotest/prev_head"
80
81 # onto the next patch:
82 msgnum=$(($msgnum + 1))
5887ac82 83 echo "$msgnum" >"$dotest/msgnum"
58634dbf
EW
84}
85
86call_merge () {
5887ac82 87 cmt="$(cat $dotest/cmt.$1)"
58634dbf 88 echo "$cmt" > "$dotest/current"
5be60078
JH
89 hd=$(git rev-parse --verify HEAD)
90 cmt_name=$(git symbolic-ref HEAD)
0bb733c9
SP
91 msgnum=$(cat $dotest/msgnum)
92 end=$(cat $dotest/end)
93 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
94 eval GITHEAD_$hd='"$(cat $dotest/onto_name)"'
95 export GITHEAD_$cmt GITHEAD_$hd
96 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
58634dbf
EW
97 rv=$?
98 case "$rv" in
99 0)
0bb733c9 100 unset GITHEAD_$cmt GITHEAD_$hd
9e4bc7dd 101 return
58634dbf
EW
102 ;;
103 1)
5be60078 104 test -d "$GIT_DIR/rr-cache" && git rerere
66eb64cb 105 die "$RESOLVEMSG"
58634dbf
EW
106 ;;
107 2)
108 echo "Strategy: $rv $strategy failed, try another" 1>&2
66eb64cb 109 die "$RESOLVEMSG"
58634dbf
EW
110 ;;
111 *)
112 die "Unknown exit code ($rv) from command:" \
113 "git-merge-$strategy $cmt^ -- HEAD $cmt"
114 ;;
115 esac
116}
117
118finish_rb_merge () {
58634dbf
EW
119 rm -r "$dotest"
120 echo "All done."
121}
122
1b1dce4b
JS
123is_interactive () {
124 test -f "$dotest"/interactive ||
125 while case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
126 do
127 shift
128 done && test -n "$1"
129}
130
131is_interactive "$@" && exec git-rebase--interactive "$@"
132
e646c9c8
JH
133while case "$#" in 0) break ;; esac
134do
135 case "$1" in
031321c6 136 --continue)
5be60078 137 git diff-files --quiet || {
06aff47b 138 echo "You must edit all merge conflicts and then"
9b07873a 139 echo "mark them as resolved using git add"
031321c6 140 exit 1
06aff47b 141 }
58634dbf
EW
142 if test -d "$dotest"
143 then
144 prev_head="`cat $dotest/prev_head`"
145 end="`cat $dotest/end`"
146 msgnum="`cat $dotest/msgnum`"
147 onto="`cat $dotest/onto`"
148 continue_merge
149 while test "$msgnum" -le "$end"
150 do
151 call_merge "$msgnum"
152 continue_merge
153 done
154 finish_rb_merge
155 exit
156 fi
f9474132 157 git am --resolved --3way --resolvemsg="$RESOLVEMSG"
cc120056
SE
158 exit
159 ;;
160 --skip)
58634dbf
EW
161 if test -d "$dotest"
162 then
f131dd49
EW
163 if test -d "$GIT_DIR/rr-cache"
164 then
5be60078 165 git rerere clear
f131dd49 166 fi
d5e673b6
EW
167 prev_head="`cat $dotest/prev_head`"
168 end="`cat $dotest/end`"
169 msgnum="`cat $dotest/msgnum`"
170 msgnum=$(($msgnum + 1))
171 onto="`cat $dotest/onto`"
172 while test "$msgnum" -le "$end"
173 do
174 call_merge "$msgnum"
175 continue_merge
176 done
177 finish_rb_merge
178 exit
58634dbf 179 fi
f9474132 180 git am -3 --skip --resolvemsg="$RESOLVEMSG"
031321c6
SE
181 exit
182 ;;
183 --abort)
f131dd49
EW
184 if test -d "$GIT_DIR/rr-cache"
185 then
5be60078 186 git rerere clear
f131dd49 187 fi
58634dbf
EW
188 if test -d "$dotest"
189 then
190 rm -r "$dotest"
191 elif test -d .dotest
192 then
193 rm -r .dotest
194 else
195 die "No rebase in progress?"
196 fi
031321c6 197 git reset --hard ORIG_HEAD
031321c6
SE
198 exit
199 ;;
e646c9c8
JH
200 --onto)
201 test 2 -le "$#" || usage
202 newbase="$2"
203 shift
204 ;;
58634dbf
EW
205 -M|-m|--m|--me|--mer|--merg|--merge)
206 do_merge=t
207 ;;
208 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
209 --strateg=*|--strategy=*|\
210 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
211 case "$#,$1" in
212 *,*=*)
8096fae7 213 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
58634dbf
EW
214 1,*)
215 usage ;;
216 *)
217 strategy="$2"
218 shift ;;
219 esac
220 do_merge=t
221 ;;
b758789c
RS
222 -v|--verbose)
223 verbose=t
224 ;;
67dad687
MT
225 -C*)
226 git_am_opt=$1
227 shift
228 ;;
e646c9c8
JH
229 -*)
230 usage
231 ;;
232 *)
233 break
234 ;;
235 esac
236 shift
237done
2db8aaec 238
7f4bd5d8 239# Make sure we do not have .dotest
58634dbf 240if test -z "$do_merge"
7f4bd5d8 241then
58634dbf
EW
242 if mkdir .dotest
243 then
244 rmdir .dotest
245 else
246 echo >&2 '
7f4bd5d8
JH
247It seems that I cannot create a .dotest directory, and I wonder if you
248are in the middle of patch application or another rebase. If that is not
249the case, please rm -fr .dotest and run me again. I am stopping in case
250you still have something valuable there.'
58634dbf
EW
251 exit 1
252 fi
253else
254 if test -d "$dotest"
255 then
256 die "previous dotest directory $dotest still exists." \
257 'try git-rebase < --continue | --abort >'
258 fi
7f4bd5d8
JH
259fi
260
7f59dbbb 261# The tree must be really really clean.
5be60078
JH
262git update-index --refresh || exit
263diff=$(git diff-index --cached --name-status -r HEAD)
32d99544 264case "$diff" in
6e598c32
DK
265?*) echo "cannot rebase: your index is not up-to-date"
266 echo "$diff"
7f59dbbb
JH
267 exit 1
268 ;;
269esac
99a92f92 270
e646c9c8
JH
271# The upstream head must be given. Make sure it is valid.
272upstream_name="$1"
273upstream=`git rev-parse --verify "${upstream_name}^0"` ||
d0080b3c 274 die "invalid upstream $upstream_name"
32d99544 275
a1bf91e0
JH
276# Make sure the branch to rebase onto is valid.
277onto_name=${newbase-"$upstream_name"}
5be60078 278onto=$(git rev-parse --verify "${onto_name}^0") || exit
a1bf91e0 279
9a111c91
JH
280# If a hook exists, give it a chance to interrupt
281if test -x "$GIT_DIR/hooks/pre-rebase"
282then
283 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
284 echo >&2 "The pre-rebase hook refused to rebase."
285 exit 1
286 }
287fi
288
7f59dbbb 289# If the branch to rebase is given, first switch to it.
59e6b23a 290case "$#" in
7f59dbbb 2912)
e646c9c8 292 branch_name="$2"
3ae39ab2 293 git-checkout "$2" || usage
e646c9c8
JH
294 ;;
295*)
bcf31618
JH
296 if branch_name=`git symbolic-ref -q HEAD`
297 then
298 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
299 else
300 branch_name=HEAD ;# detached
301 fi
e646c9c8 302 ;;
59e6b23a 303esac
5be60078 304branch=$(git rev-parse --verify "${branch_name}^0") || exit
59e6b23a 305
e646c9c8
JH
306# Now we are rebasing commits $upstream..$branch on top of $onto
307
1308c17b
JS
308# Check if we are already based on $onto with linear history,
309# but this should be done only when upstream and onto are the same.
5be60078 310mb=$(git merge-base "$onto" "$branch")
1308c17b
JS
311if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
312 # linear history?
313 ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
7f4bd5d8 314then
83c31614
RS
315 echo >&2 "Current branch $branch_name is up to date."
316 exit 0
7f4bd5d8
JH
317fi
318
b758789c
RS
319if test -n "$verbose"
320then
321 echo "Changes from $mb to $onto:"
fefe49d1 322 # We want color (if set), but no pager
5be60078 323 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
b758789c
RS
324fi
325
e646c9c8 326# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
228e2eb6 327echo "First, rewinding head to replay your work on top of it..."
e646c9c8 328git-reset --hard "$onto"
32d99544 329
e646c9c8 330# If the $onto is a proper descendant of the tip of the branch, then
32d99544 331# we just fast forwarded.
83c31614 332if test "$mb" = "$branch"
32d99544 333then
d587ed13 334 echo >&2 "Fast-forwarded $branch_name to $onto_name."
32d99544
LS
335 exit 0
336fi
337
58634dbf
EW
338if test -z "$do_merge"
339then
5be60078 340 git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
67dad687 341 git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
58634dbf
EW
342 exit $?
343fi
344
345# start doing a rebase with git-merge
346# this is rename-aware if the recursive (default) strategy is used
347
348mkdir -p "$dotest"
349echo "$onto" > "$dotest/onto"
0bb733c9 350echo "$onto_name" > "$dotest/onto_name"
5be60078 351prev_head=`git rev-parse HEAD^0`
58634dbf
EW
352echo "$prev_head" > "$dotest/prev_head"
353
354msgnum=0
5be60078 355for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
58634dbf
EW
356do
357 msgnum=$(($msgnum + 1))
5887ac82 358 echo "$cmt" > "$dotest/cmt.$msgnum"
58634dbf
EW
359done
360
5887ac82
JH
361echo 1 >"$dotest/msgnum"
362echo $msgnum >"$dotest/end"
58634dbf
EW
363
364end=$msgnum
365msgnum=1
366
367while test "$msgnum" -le "$end"
368do
369 call_merge "$msgnum"
370 continue_merge
371done
cc120056 372
58634dbf 373finish_rb_merge